import RPi.GPIO as GPIO
import time
import snapcast.control
from snapcast import get_snapcast_client
from snapcast import add_server

SENSOR_PIN = 7
MUTE_BRIGHTNESS = 0.1


def dark_mute():
    '''Runs measure_brightness and prints output'''
    server = snapcast.control.Snapserver(add_server(),
                                         snapcast.control.CONTROL_PORT)
    client = get_snapcast_client(server)
    GPIO.setmode(GPIO.BOARD)
    try:
        while True:
            #  TODO: track current state, don't send constant updates
            brightness = measure_brightness(SENSOR_PIN)
            if brightness < MUTE_BRIGHTNESS:
                client.muted = True
            else:
                client.muted = False
    except KeyboardInterrupt:
        pass
    finally:
            GPIO.cleanup()


def measure_brightness(pin_to_circuit):
    '''Measure brightness using photoresistor-capacitor circuit.'''
    charge_time = 0

    GPIO.setup(pin_to_circuit, GPIO.OUT)
    GPIO.output(pin_to_circuit, GPIO.LOW)
    time.sleep(0.1)

    GPIO.setup(pin_to_circuit, GPIO.IN)

    while (GPIO.input(pin_to_circuit) == GPIO.LOW):
        charge_time += 1

    return 1000/charge_time


if __name__ == '__main__':
    dark_mute()
